unit CorpExample_IMPL;
interface
uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, Office2000, adxAddIn, CorpExample_TLB,
  Classes, DB, ADODB, adxHostAppEvents, Dialogs, StdVcl;

type
  TCoCorpExample = class(TadxAddin, ICoCorpExample)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    adxOutlookAppEvents1: TadxOutlookAppEvents;
    procedure adxCOMAddInModuleCreate(Sender: TObject);
    procedure adxOutlookAppEvents1Quit(Sender: TObject);
    procedure adxCOMAddInModuleAddInBeginShutdown(Sender: TObject);
    procedure adxCOMAddInModuleAddInFinalize(Sender: TObject);
  private
  protected
  public
    bFastShutdown: Boolean;
    procedure MergedClose;
  end;

implementation

{$R *.dfm}

procedure TAddInModule.adxCOMAddInModuleCreate(Sender: TObject);
begin
  bFastShutdown := false;
end;

procedure TAddInModule.adxCOMAddInModuleAddInBeginShutdown(Sender: TObject);
begin
  MergedClose;
end;

procedure TAddInModule.adxCOMAddInModuleAddInFinalize(Sender: TObject);
begin
  //Nothing to do
end;

procedure TAddInModule.adxOutlookAppEvents1Quit(Sender: TObject);
begin
  MergedClose;
end;

procedure TAddInModule.MergedClose;
begin
  if bFastShutdown then  // Semaphore to prevent Shutdown called twice.
    Exit;
  bFastShutDown := true;
  // Save toolbars
  // Free any memory
  // Close any pending database connection (if file-based)
end;

initialization
  TadxFactory.Create(ComServer, TCoCorpExample, CLASS_CoCorpExample, TAddInModule);

end.
